#include <fstream>
#include <iostream>
#include <list>
#include <stdio.h>
#include <stdlib.h>
#include "mobile.h"

using namespace std;

typedef std::list<Mobile*>  MobileList;
typedef std::list<Selling*> SellingList;

//------------------------------------------------------------
Mobile* selectMobile    (MobileList& mobileList);
void printMobileList    (MobileList& mobileList);

void addBlackWhiteMobile (MobileList& mobileList);
void addColorMobile      (MobileList& mobileList);
void addFotoMobile       (MobileList& mobileList);

void sellMobile         (MobileList& fl, SellingList& sl);
void showMobileDetails  (MobileList& mobileList, SellingList& sellingList);
void showProfit         (SellingList& sellingList);

void cleaning           (MobileList& mobileList, SellingList& sellingList);

//------------------------------------------------------------

int main () {
    MobileList    mobileList;
    SellingList sellingList;
    
    //----------------- load BlackWhiteMobile.txt ------------
    ifstream inFileBWM ("BlackWhiteMobile.txt");
    string name;
    try {
        if(inFileBWM.fail()) 
            throw string("Nerastas failas tokiu pavadinimu: BlackWhiteMobile.txt");
        inFileBWM >> name;
        while(inFileBWM.good()) {
            double discount;
            inFileBWM >> discount;
            double price;
            inFileBWM >> price;
            mobileList.push_back(new BlackWhiteMobile(name, discount, price));
            inFileBWM >> name;
        }
    }
    catch(string ex) {
        cout << "Error: " << ex << endl;
    }    
    inFileBWM.close(); 
    
    //----------------- load ColorMobile.txt -----------------
    ifstream inFileCM ("ColorMobile.txt");
    try {
        if(inFileCM.fail()) 
            throw string("Nerastas failas tokiu pavadinimu: ColorMobile.txt");
        inFileCM >> name;
        while(inFileCM.good()) {
            double discount;
            inFileCM >> discount;
            double price;
            inFileCM >> price;
            mobileList.push_back(new ColorMobile(name, discount, price));
            inFileCM >> name;
        }
    }
    catch(string ex) {
        cout << "Error: " << ex << endl;
    }    
    inFileCM.close(); 

    //----------------- load FotoMobile.txt -----------------
    ifstream inFileFM ("FotoMobile.txt");
    try {
        if(inFileFM.fail()) 
            throw string("Nerastas failas tokiu pavadinimu: FotoMobile.txt");
        inFileFM >> name;
        while(inFileFM.good()) {
            double discount;
            inFileFM >> discount;
            double price;
            inFileFM >> price;
            mobileList.push_back(new FotoMobile(name, discount, price));
            inFileFM >> name;
        }
    }
    catch(string ex) {
        cout << "Error: " << ex << endl;
    }    
    inFileFM.close(); 
    
//------------------------ load Selling.txt -----------------
    ifstream inFile ("Selling.txt");
    try {
        if(inFile.fail()) 
            throw string("Nerastas failas tokiu pavadinimu: Selling.txt");
        inFile >> name;
        while(inFile.good()) {
            string date;
            inFile >> date;
            int itemCount;
            inFile >> itemCount;
            double itemPrice;
            inFile >> itemPrice;
            MobileList ::iterator iter = mobileList.begin(); 
            for(;  iter != mobileList.end();  iter++) {
	            if(name == (*iter)->getName()) {
                    Selling* selling = new Selling((*iter), date, itemCount,itemPrice);  
                    sellingList.push_back(selling);
                }                          
	        }          
            inFile >> name;
        } 
    }        
    catch(string ex) {
        cout << "Error: " << ex << endl;
    }
    inFile.close();   

//-------------------------------------------------------------------
   
    for (;;) {
        cout << endl
             << "|-----------------------------------------|" << endl
             << "|  Mobilieji telefonai                    |" << endl
             << "|-----------------------------------------|" << endl
             << "|   => 1 - sarasas                        |" << endl
             << "|   => 2 - registruoti nauja              |" << endl
             << "|   => 3 - uzsakymas                      |" << endl
             << "|   => 4 - informacija                    |" << endl
             << "|   => 5 - laikotarpio pelnas             |" << endl  
             << "|   => 0 - baigti                         |" << endl
             << "|-----------------------------------------|" << endl
             << "|====> ";
        string key; 
        cin >> key;
        
        if(key == "0") {
            cleaning(mobileList, sellingList); 
            return 0;
        }
        else if(key == "1") printMobileList(mobileList);
        else if(key == "2") { 
            cout << "Pasirinkite: "<< endl
                 << "Nespalvotas telefonas - [1]" << endl
                 << "Spalvotas   telefonas - [2]" << endl
                 << "Telefonas su foto     - [3]" << endl
                 << "=>";
            string action;
            cin >> action;
            if(action == "1")             
                try {  
                    addBlackWhiteMobile(mobileList);
                }
                catch(string e1) {
                    cout << "Error: " << e1 << endl;
                }
            else if(action == "2") 
                try { 
                    addColorMobile(mobileList);
                }
                catch(string e2) {
                    cout << "Error: " << e2 << endl;
                }
            else if(action == "3") 
                try { 
                    addFotoMobile(mobileList);
                }
                catch(string e3) {
                    cout << "Error: " << e3 << endl;
                }
            else cout << endl << "Neteisinga komanda..." << endl;    
        }         
        else if(key == "3") 
            try {
                sellMobile(mobileList, sellingList);
            }
            catch(string e4) {
                cout << "Error: " << e4 << endl;
            }  
        else if(key == "4") showMobileDetails(mobileList,sellingList);
        else if(key == "5") 
            try {
                showProfit(sellingList);
            }
            catch(string e5) {
                cout << "Error: " << e5 << endl;
            }
        else cout << endl << "Neteisinga komanda..." << endl;
    }
}

//-------------------------------------------------------------------
void cleaning(MobileList& mobileList,SellingList& sellingList) {
    
    MobileList::iterator it = mobileList.begin();
    for(; it != mobileList.end(); it++)
        delete (*it);    
         
    SellingList::iterator itr = sellingList.begin();
    for( ;itr != sellingList.end(); itr++)
        delete (*itr);
}
//------------------------------------------------------------
Mobile* selectMobile (MobileList& mobileList) {
    for (;;) {
        string name;
        printMobileList(mobileList);
        cout << "Pasirinkite mob. telefona ('q'-baigti): ";
        cin >> name;
        if (name == "q") return 0;
        MobileList::iterator iter = mobileList.begin();
        for(;  iter != mobileList.end();  iter++)
            if(name == (*iter)->getName())
                return *iter;
   }
   return 0; 
}
//------------------------------------------------------------
void printMobileList (MobileList& mobileList) {
    cout << " Mob. telefonu sarasas: " << mobileList.size() << endl;
    MobileList::iterator iter = mobileList.begin();
    for(;  iter != mobileList.end();  iter++)
        (*iter)->print();
}
//------------------------------------------------------------
void addBlackWhiteMobile (MobileList& mobileList) {  
    string name;
    char temp[256];
    double discount = 0;
    double price = 0;
  
    cout << " Naujas nespalvotas mob. telefonas:" << endl;
    cout << " Pavadinimas: ";      
    cin >> name; 
    
    cout << " Nuolaida perkant daugiau nei 2 vnt.: ";      
    cin >> temp;  
    discount = atof(temp);
    if(discount == 0) throw string ("nuolaidos ivedimas!");    
    
    cout << " Vieneto kaina (Lt): ";
    cin >> temp;
    price = atof(temp); 
    if(price==0) throw string ("kainos ivedimas!");
    
    mobileList.push_back(new BlackWhiteMobile(name, discount, price));
    
    //------------------- Save to BlackWhiteMobile.txt ------
    ofstream outFilep("BlackWhiteMobile.txt", ios:: app);
    outFilep << name << " " << discount << " " << price << endl;
    outFilep.close();
}
//-----------------------------------------------------------
void addColorMobile (MobileList& mobileList) {  
    string name;
    char temp[256];
    double discount = 0;
    double price = 0;
   
    cout << " Naujas spalvotas mob. telefonas:" << endl;
    cout << " Pavadinimas: ";      
    cin >> name; 
    
    cout << " Nuolaida perkant daugiau nei 2 vnt.: ";      
    cin >> temp;  
    discount = atof(temp);
    if(discount == 0) throw string ("nuolaidos ivedimas!");    
    
    cout << " Vieneto kaina (Lt): ";
    cin >> temp;
    price = atof(temp); 
    if(price==0) throw string ("kainos ivedimas!");
    
    mobileList.push_back(new ColorMobile(name, discount, price));
   
    //------------------- Save to ColorMobile.txt ------------
    ofstream outFiles("ColorMobile.txt", ios:: app);
    outFiles << name << " " << discount << " " << price << endl;
    outFiles.close();
}
//-----------------------------------------------------------
void addFotoMobile (MobileList& mobileList) {  
    string name;
    char temp[256];
    double discount = 0;
    double price = 0;
   
    cout << " Naujas mob. telefonas su Foto:" << endl;
    cout << " Pavadinimas: ";      
    cin >> name; 
    
    cout << " Nuolaida perkant daugiau nei 2 vnt.: ";      
    cin >> temp;  
    discount = atof(temp);
    if(discount == 0) throw string ("nuolaidos ivedimas!");    
    
    cout << " Vieneto kaina (Lt): ";
    cin >> temp;
    price = atof(temp); 
    if(price==0) throw string ("kainos ivedimas!");
    
    mobileList.push_back(new FotoMobile(name, discount, price));
   
    //------------------- Save to ColorMobile.txt ------------
    ofstream outFiles("FotoMobile.txt", ios:: app);
    outFiles << name << " " << discount << " " << price << endl;
    outFiles.close();
}        
//------------------------------------------------------------
void sellMobile (MobileList& mobileList, SellingList& sellingList) {  
    string name;
    char tmp[256];
    string date;
    int    itemCount = 0;
    double itemPrice = 0;
    cout << "Pardavimo data (MMMM-mm-dd): "; 
    cin >> date;
    for(;;) {
        cout << "Mob. telefono pardavimas" << endl;
        Mobile* mobile = selectMobile(mobileList);
        if(mobile == 0) return;
        mobile->print();
        cout << "Vienetu skaicius: ";
        cin >> tmp;
        itemCount = atoi (tmp); 
        if(itemCount == 0) throw string ("kiekio ivedimas!");
        if(itemCount > 2) {
            //pridedame prie nupirktos kainos 10%
            double newPrice = mobile->getPrice() * 1.1;
            //siai naujai kainai taikome nuolaidas
            itemPrice = newPrice - mobile->getDiscount();     
        }
        else {
            cout << "Vieneto kaina (Lt): ";
            cin >> tmp;
            itemPrice = atof(tmp);
            //pridedame prie nupirktos kainos 10% 
            itemPrice = itemPrice * 1.1;
            if (itemPrice == 0) throw string ("kainos ivedimas!");    
        }    
        //------------------- Save to Selling.txt -----------------
        ofstream outFile("Selling.txt", ios:: app);    
        outFile << mobile->getName() 
            << " " << date 
            << " " << itemCount
            << " " << itemPrice 
            << endl;
        outFile.close();
        //----------------------------------------------------------
        SellingList::iterator iter;
        Selling* selling = new Selling(mobile, date, itemCount, itemPrice);
        mobile->addSelling(selling);
        sellingList.push_back(selling);
    }   
}
//------------------------------------------------------------
void showMobileDetails(MobileList& mobileList,SellingList& sellingList) {  
    cout << "Mob.telefono pardavimo detales: " << endl;
    Mobile* mobile = selectMobile(mobileList);
    if(mobile == 0) return;
    mobile->print();
    SellingList::iterator iter = sellingList.begin();
    for(;  iter != sellingList.end();  iter++) { 
        if((*iter)->getMobile()->getName() == mobile->getName()) {
	        cout << (*iter)->getMobile()->getName();
	        cout << " ";	   
            cout << (*iter)->getDate();
            cout << " ";	   
            cout << (*iter)->getItemCount() ;
            cout << " ";	 
            cout << (*iter)->getItemPrice() << endl;
            cout << " "; 
        }    	                       
	}    
}
//------------------------------------------------------------
void showProfit(SellingList& sellingList) { 
    string from;
    string to;
    cout << "Laikotarpio pardavimu pelnas :" << endl;
    cout << "Nuo (MMMM-mm-dd): "; 
    cin >> from;
    cout << "Iki (MMMM-mm-dd): "; 
    cin >> to;
    double totalProfit =  0;
    double totalExpense = 0;
    double totalIncome =  0;
    SellingList::iterator it = sellingList.begin();
    for(;  it != sellingList.end();  it++)
        if(from <= (*it)->getDate() && (*it)->getDate() <= to) {
            (*it)->print();
            totalProfit  +=(*it)->getProfit();  
            totalExpense +=(*it)->getExpense(); 
            totalIncome  +=(*it)->getIncome();
        }
    cout << "Islaidos: " << totalExpense << endl;
    cout << "Pajamos: "  << totalIncome  << endl;
    cout << "Pelnas: "   << totalProfit  << endl;
}
//--------------------------------------------------------------


 
