#include <iostream>
#include "mobile.h" 

using namespace std;

Mobile::Mobile (const string& name)
 : name (name)
{ 
}
//------------------------------------------------------------
Mobile::Mobile (const Mobile& mobile)
 : name(mobile.name)
{
}
//------------------------------------------------------------
void Mobile::print (const string& margin) const {
    cout << margin << name 
         << " \t" << getDiscount()
         << " \t" << getPrice() <<  endl;
}
//------------------------------------------------------------
double Mobile::getProfit () const {
    double profit = 0;
    vector<Selling*>::const_iterator iter = sellings.begin();
    for(;  iter != sellings.end();  iter++)
        profit += (*iter)->getProfit();
    return profit;   
}
//-----------------------------------------------------------
double Mobile::getExpense() const {
    double expense = 0;
    vector<Selling*>::const_iterator iter = sellings.begin();
    for(;  iter != sellings.end();  iter++)
        expense += (*iter)->getExpense();
    return expense;   
}
//------------------------------------------------------------
double Mobile::getIncome() const {
    double income = 0;
    vector<Selling*>::const_iterator iter = sellings.begin();
    for(;  iter != sellings.end();  iter++)
        income += (*iter)->getIncome();
    return income;   
}
//------------------------------------------------------------
void Mobile::addSelling(Selling* selling) {
    sellings.push_back(selling);
}
//------------------------------------------------------------
BlackWhiteMobile::BlackWhiteMobile (const string& name, double discount, double price)
 : Mobile  (name),
   discount (discount),
   price (price)
{
}
//------------------------------------------------------------
BlackWhiteMobile::BlackWhiteMobile(const BlackWhiteMobile& mobile)
 : Mobile  (mobile),
   discount (mobile.discount),
   price (mobile.price)
{
}
//------------------------------------------------------------
Mobile* BlackWhiteMobile::clone() const {
   return new BlackWhiteMobile(*this);
}
//------------------------------------------------------------
ColorMobile::ColorMobile (const string& name, double discount, double price)
 : Mobile  (name),
   discount (discount),
   price (price)
{
}
//------------------------------------------------------------
ColorMobile::ColorMobile(const ColorMobile& mobile)
 : Mobile  (mobile),
   discount (mobile.discount),
   price (mobile.price)
{
}
//------------------------------------------------------------
Mobile* ColorMobile::clone() const {
   return new ColorMobile(*this);
}
//------------------------------------------------------------
FotoMobile::FotoMobile (const string& name, double discount, double price)
 : Mobile  (name),
   discount (discount),
   price (price)
{
}
//------------------------------------------------------------
FotoMobile::FotoMobile(const FotoMobile& mobile)
 : Mobile  (mobile),
   discount (mobile.discount),
   price (mobile.price)
{
}
//------------------------------------------------------------
Mobile* FotoMobile::clone() const {
   return new FotoMobile(*this);
}
//------------------------------------------------------------
