#include <iostream>
#include "selling.h"
#include "mobile.h"

using namespace std;

//------------------------------------------------------------
Selling::Selling (const Mobile* mobile, const std::string& date, int itemCount, double itemPrice) {                  
   this->mobile    = mobile;
   this->date      = date;
   this->itemCount = itemCount;
   this->itemPrice = itemPrice;
}
//--------------------- pelnas ---------------------------------------
double Selling::getProfit () const {
   return itemCount * (itemPrice - mobile->getPrice());
}
//--------------------- islaidos -------------------------------------
double Selling::getExpense () const {
   return itemCount * mobile->getPrice();
}
//--------------------- pajamos --------------------------------------
double Selling::getIncome () const {
   return itemCount * itemPrice;
}
//------------------------------------------------------------
void Selling::print () const {
   cout << " " << mobile->getName()       
        << " " << date
        << " " << itemCount
        << " " << itemPrice
        << " islaidos= " << getExpense()
        << " pajamos= " << getIncome()
        << " pelnas= " << getProfit() 
        << endl;
}
//------------------------------------------------------------
